#include "stdafx.h"
#include "ip_view.h"
using namespace editwing;
using namespace editwing::view;



//=========================================================================
//---- ip_scroll.cpp XN[
//
//		EChETCY̓XN[o[̈ʒuɂ
//		`ʒuKɍXVĂB
//
//---- ip_text.cpp   񑀍E
//---- ip_parse.cpp  L[[h
//---- ip_wrap.cpp   ܂Ԃ
//---- ip_draw.cpp   `E
//---- ip_cursor.cpp J[\Rg[
//=========================================================================



//-------------------------------------------------------------------------
// `̈TCYǗ
//-------------------------------------------------------------------------

namespace
{
	static int Log10( ulong n )
	{
		const static ulong power_of_ten[] =
			{ 1, 10, 100, 1000, 10000, 100000, 1000000,
			  10000000, 100000000, 1000000000 }; // 10^0 ` 10^9
		int c=3;
		if( power_of_ten[9] <= n )
			c=10;
		else
			while( power_of_ten[c] <= n )
				c++;
		return c; // 3<=c<=10 s.t. 10^(c-1) <= n < 10^c
	}
}

bool Canvas::CalcLNAreaWidth()
{
	const int prev = txtZone_.left;
	if( showLN_ )
	{
		txtZone_.left  = (1 + figNum_) * font_->F();
		if( txtZone_.left+font_->W() >= txtZone_.right )
			txtZone_.left = 0; // sԍ][fJƂ͕\Ȃ
	}
	else
	{
		txtZone_.left = 0;
	}

	return (prev != txtZone_.left);
}

void Canvas::CalcWrapWidth()
{
	switch( wrapType_ )
	{
	case NOWRAP:
		wrapWidth_ = 0xffffffff;
		break;
	case RIGHTEDGE:
		wrapWidth_ = txtZone_.right - txtZone_.left - 3;
		break; //Caret̕-3␳
	default:
		wrapWidth_ = wrapType_ * font_->W();
		break;
	}
}

Canvas::Canvas( const View& vw )
	: wrapType_ ( -1 )
	, showLN_   ( false )
	, wrapWidth_( 0xffffffff )
	, figNum_   ( 3 )
	, font_     ( new Painter( ::GetDC(vw.hwnd()),
	                  VConfig(TEXT("FixedSys"),14) ) )
{
	vw.getClientRect( &txtZone_ );
}

bool Canvas::on_view_resize( int cx, int cy )
{
	txtZone_.right  = cx;
	txtZone_.bottom = cy;

	CalcLNAreaWidth();
	if( wrapType_ == RIGHTEDGE )
	{
		CalcWrapWidth();
		return true;
	}
	return false;
}

void Canvas::on_font_change( const VConfig& vc )
{
	HDC dc = font_->getDC();
	font_ = NULL; // ɃfXgN^Ă΂˂΂ȂȂc
	              // Ă[iD[[[(T_T)
	font_ = new Painter( dc, vc );

	CalcLNAreaWidth();
	CalcWrapWidth();
}

void Canvas::on_config_change( int wrap, bool showln )
{
	showLN_ = showln;
	wrapType_ = wrap;

	CalcLNAreaWidth();
	CalcWrapWidth();
}

bool Canvas::on_tln_change( ulong tln )
{
	figNum_ = Log10( tln ); // vZ

	if( CalcLNAreaWidth() )
	{
		if( wrapType_ == RIGHTEDGE )
			CalcWrapWidth();
		return true;
	}
	return false;
}



//-------------------------------------------------------------------------
// XN[o[vZ[`
//-------------------------------------------------------------------------
// rl (XN[)
// max:  view.txt.txtwidth()
// page: view.cx()
// pos:  0`max-page

// ud (cXN[)
// max:   view.txt.vln() + page - 1
// page:  view.cy() / view.fnt.H()
// delta: 0`view.fnt.H()
// pos:   0`max-page (top̍sԍ)

bool ViewImpl::ReSetScrollInfo()
{
	const int prevRlPos = rlScr_.nPos;
	const ulong cx = cvs_.zone().right - cvs_.zone().left;
	const ulong cy = cvs_.zone().bottom;

	// ͕ςȒlɂȂȂ悤␳邾ł悢
//	rlScr_.nPage = cx + 1;
//	rlScr_.nMax  = Max( textCx_, cx );
//	rlScr_.nPos  = Min<int>( rlScr_.nPos, rlScr_.nMax-rlScr_.nPage+1 );
	rlScr_.nPage = cx + 1;
	rlScr_.nMax  = Max( textCx_+3, cx );
	rlScr_.nPos  = Min<int>( rlScr_.nPos, rlScr_.nMax-rlScr_.nPage+1 );

	// cnPagenMax͂Ƃ肠␳
	// nPos͏ꍇɂĒقȂ̂ŕʃ[`ɂ
	udScr_.nPage = cy / cvs_.getPainter().H() + 1;
	udScr_.nMax  = vln() + udScr_.nPage - 2;

	// XN[Ntrue
	return (prevRlPos != rlScr_.nPos);
}

void ViewImpl::ForceScrollTo( ulong tl )
{
	udScr_.nPos = tl2vl(tl);
	udScr_tl_   = tl;
	udScr_vrl_  = 0;
}

ulong ViewImpl::tl2vl( ulong tl ) const
{
	if( vln() == doc_.tln() )
		return tl;

	ulong vl=0;
	for( ulong i=0; i<tl; ++i )
		vl += rln(i);
	return vl;
}

void ViewImpl::UpdateScrollBar()
{
	::SetScrollInfo( hwnd_, SB_HORZ, &rlScr_, TRUE );
	::SetScrollInfo( hwnd_, SB_VERT, &udScr_, TRUE );
}

ReDrawType ViewImpl::TextUpdate_ScrollBar
	( const DPos& s, const DPos& e, const DPos& e2 )
{
	const ulong prevUdMax = udScr_.nMax;
	const bool rlScrolled = ReSetScrollInfo();
	const long vl_dif = (udScr_.nMax - prevUdMax);
	ReDrawType ans =
		(vl_dif!=0 || s.tl!=e2.tl ? AFTER : LINE);

	if( udScr_tl_ < s.tl )
	{
		// p^[PF݂̉ʏ[艺ōXVꂽꍇ
		// XN[Ȃ
	}
	else if( udScr_tl_ == s.tl )
	{
		// p^[QF݂̉ʏ[ƓsōXVꂽꍇ
		// o邾ʒu\悤Ǝ݂B

		if( static_cast<ulong>(udScr_.nPos) >= vln() )
		{
			// p^[2-1F͂łEOFI
			// [Ȃ̂ňԉ̍s\
			udScr_.nPos = vln()-1;
			udScr_tl_   = doc_.tln()-1;
			udScr_vrl_  = rln(udScr_tl_)-1;
			ans = ALL;
		}
		else
		{
			// p^[2-2F
			// XN[
			while( udScr_vrl_ >= rln(udScr_tl_) )
			{
				udScr_vrl_ -= rln(udScr_tl_);
				udScr_tl_++;
			}
		}
	}
	else
	{
		// p^[RF݂̉ʏ[ōXVꂽꍇ
		// \eςȂ悤Ɋ撣

		if( e.tl < udScr_tl_ )
		{
			// p^[3-1FύX͈͂̏I[Aݍs̏ꍇ
			// sԍ͕ς邪\e͕ςȂōς
			udScr_.nPos += vl_dif;
			udScr_tl_   += (e2.tl - e.tl);
			ans = LNAREA;
		}
		else
		{
			// p^[3-2F
			// ǂ[Ȃ̂œKȈʒuɃXN[
			ForceScrollTo( e2.tl );
			ans = ALL;
		}
	}

	// ǂȍĕ`΂悢Ԃ
	return (rlScrolled ? ALL : ans);
}

void ViewImpl::ScrollTo( const VPos& vp )
{
	// tH[JX
	int dx=0;
	if( vp.vx < (signed)rlScr_.nPos )
	{
		dx = vp.vx - rlScr_.nPos;
	}
	else
	{
		const int W = cvs_.getPainter().W();
		if( rlScr_.nPos + (signed)(rlScr_.nPage-W) <= vp.vx )
			dx = vp.vx - (rlScr_.nPos + rlScr_.nPage) + W;
	}

	// ctH[JX
	int dy=0;
	if( vp.vl < (unsigned)udScr_.nPos )
		dy = vp.vl - udScr_.nPos;
	else if( udScr_.nPos + (udScr_.nPage-1) <= vp.vl )
		dy = vp.vl - (udScr_.nPos + udScr_.nPage) + 2;

	// XN[
	if( dy!=0 )	UpDown( dy, dx==0 );
	if( dx!=0 )	ScrollView( dx, 0, true );
}

void ViewImpl::GetDrawPosInfo( VDrawInfo& v ) const
{
	const int H = cvs_.getPainter().H();

	long most_under = (vln()-udScr_.nPos)*H;
	if( most_under <= v.rc.top )
	{
		v.YMIN  = v.rc.top;
		v.YMAX  = most_under;
	}
	else
	{
		int    y = -(signed)udScr_vrl_;
		ulong tl = udScr_tl_;
		int  top = v.rc.top / H;
		while( y + (signed)rln(tl) <= top )
			y += rln( tl++ );

		// cW
		v.YMIN  = y * H;
		v.YMAX  = Min( v.rc.bottom, most_under );
		v.TLMIN = tl;

		// W
		v.XBASE = left() - rlScr_.nPos;
		v.XMIN  = v.rc.left  - v.XBASE;
		v.XMAX  = v.rc.right - v.XBASE;

		// I͈
		v.SXB = v.SXE = v.SYB = v.SYE = 0x7fffffff;

		const VPos *bg, *ed;
		if( cur_.getCurPos( &bg, &ed ) )
		{
			v.SXB = bg->vx - rlScr_.nPos + left();
			v.SXE = ed->vx - rlScr_.nPos + left();
			v.SYB = (bg->vl - udScr_.nPos) * H;
			v.SYE = (ed->vl - udScr_.nPos) * H;
		}
	}
}

void ViewImpl::ScrollView( int dx, int dy, bool update )
{
	// XN[Jnʒm
	cur_.on_scroll_begin();

	const RECT* clip = (dy==0 ? &cvs_.zone() : NULL);
	const int H = cvs_.getPainter().H();

	// XN[o[XV
	if( dx != 0 )
	{
		// ͈̓`FbN
		if( rlScr_.nPos+dx < 0 )
			dx = -rlScr_.nPos;
		else if( rlScr_.nMax-(signed)rlScr_.nPage < rlScr_.nPos+dx ) 
			dx = rlScr_.nMax-rlScr_.nPage-rlScr_.nPos+1;

		rlScr_.nPos += dx;
		::SetScrollInfo( hwnd_, SB_HORZ, &rlScr_, TRUE );
		dx = -dx;
	}
	if( dy != 0 )
	{
		// ͈̓`FbNc͑OŏIĂB

		udScr_.nPos += dy;
		::SetScrollInfo( hwnd_, SB_VERT, &udScr_, TRUE );
		dy *= -H;
	}
	if( dx!=0 || dy!=0 )
	{
		if( -dx>=right() || dx>=right()
		 || -dy>=bottom() || dy>=bottom() )
		{
			// Sʍĕ`
			// 傤65536̔{炢XN[ƂɁA
			// ScrollWindowEx on Win9x ƍĕ`悪ςȂ̂B
			::InvalidateRect( hwnd_, NULL, FALSE );
		}
		else
		{
			// ĕ`̕svȗ̈XN[
			::ScrollWindowEx( hwnd_, dx, dy, NULL, 
					clip, NULL, NULL, SW_INVALIDATE );

			// ĕ`H
			if( update )
			{
				// cXN[͍̂ňHv
				if( dy != 0 )
				{
					// ĕ`̕Kvȗ̈ŌvZ
					RECT rc = {0,0,right(),bottom()};
					if( dy < 0 ) rc.top  = rc.bottom + dy;
					else         rc.bottom = dy;

					// Ce}EX̒{^NbNɂ
					// I[gXN[pJ[\̉̕ɕ`
					// Qɕ邱ƂŁAȋ`ōςނ̂ō
					::ValidateRect( hwnd_, &rc );
					::UpdateWindow( hwnd_ );
					::InvalidateRect( hwnd_, &rc, FALSE );
				}
				::UpdateWindow( hwnd_ );
			}
		}
	}

	// XN[Iʒm
	cur_.on_scroll_end();
}

void ViewImpl::on_hscroll( int code )
{
	// ωʂvZ
	int dx;
	switch( code )
	{
	default:           return;
	case SB_LINELEFT:  dx= -cvs_.getPainter().W(); break;
	case SB_LINERIGHT: dx= +cvs_.getPainter().W(); break;
	case SB_PAGELEFT:  dx= -(cx()>>1); break;
	case SB_PAGERIGHT: dx= +(cx()>>1); break;
	case SB_THUMBTRACK:
		{
			SCROLLINFO si = { sizeof(SCROLLINFO), SIF_TRACKPOS };
			::GetScrollInfo( hwnd_, SB_HORZ, &si );
			dx = si.nTrackPos - rlScr_.nPos;
			break;
		}
	case SB_LEFT:    dx = -rlScr_.nPos; break;
	case SB_RIGHT:   dx = rlScr_.nMax+1-(signed)rlScr_.nPage-rlScr_.nPos; break;
	}

	// XN[
	ScrollView( dx, 0, code!=SB_THUMBTRACK );
}

void ViewImpl::on_vscroll( int code )
{
	// ωʂvZ
	int dy;
	switch( code )
	{
	default:          return;
	case SB_LINEUP:   dy= -1; break;
	case SB_LINEDOWN: dy= +1; break;
	case SB_PAGEUP:   dy= -(cy() / cvs_.getPainter().H()); break;
	case SB_PAGEDOWN: dy= +(cy() / cvs_.getPainter().H()); break;
	case SB_THUMBTRACK:
		{
			SCROLLINFO si = { sizeof(SCROLLINFO), SIF_TRACKPOS };
			::GetScrollInfo( hwnd_, SB_VERT, &si );
			dy = si.nTrackPos - udScr_.nPos;
			break;
		}
	case SB_TOP:      dy = -udScr_.nPos; break;
	case SB_BOTTOM:   dy = udScr_.nMax+1-(signed)udScr_.nPage-udScr_.nPos; break;
	}

	// XN[
	UpDown( dy, code==SB_THUMBTRACK );
}

void ViewImpl::on_wheel( short delta )
{
	// XN[
	UpDown( -delta / WHEEL_DELTA * 3, false );
}

void ViewImpl::UpDown( int dy, bool thumb )
{
  // PDudScr_.nPos + dy ͈͂Ɏ܂悤ɕ␳
	if( udScr_.nPos+dy < 0 )
		dy = -udScr_.nPos;
	else if( udScr_.nMax+1-(signed)udScr_.nPage < udScr_.nPos+dy ) 
		dy = udScr_.nMax+1-udScr_.nPage-udScr_.nPos;
	if( dy==0 )
		return;

  // Q|PD܂Ԃ̏ꍇ͈CɃWvo
	if( !wrapexists() )
	{
		udScr_tl_ = udScr_.nPos + dy;
	}

  // Q|QDłȂA݈ʒȗ΃T[`
  // ScrollBarAIɃhbOxɈCɔ񂾏ꍇ
  // 1sڂŏIs̑΃T[`̕Lȉ\邪A
  // ̏ꍇ͑xxȂĂ`悪邱Ƃ͂Ȃ̂łnj
	else
	{
		int   rl = dy + udScr_vrl_;
		ulong tl = udScr_tl_;

		if( dy<0 ) // ֖߂ꍇ
		{
			// Wv_s̍sDash!
			while( rl < 0 )
				rl += rln(--tl);
		}
		else if( dy>0 ) // ֐iޏꍇ
		{
			// Wv_s̍sDash!
			while( rl > 0 )
				rl -= rln(tl++);
			if( rl < 0 )
				rl += rln(--tl); //s߂C
		}
		udScr_tl_ = tl;
		udScr_vrl_= static_cast<ulong>(rl);
	}

  // SDʂXN[
	ScrollView( 0, dy, !thumb );
}

void ViewImpl::InvalidateView( const DPos& dp, bool afterall ) const
{
	const int H = cvs_.getPainter().H();

	// \ł̍XV
	if( dp.tl < udScr_tl_ )
	{
		if( afterall )
			::InvalidateRect( hwnd_, NULL, FALSE );
		return;
	}

	// JnyWvZ
	int r=0, yb=-(signed)udScr_vrl_;
	for( int t=udScr_tl_, ybe=cy()/H; (unsigned)t<dp.tl; yb+=rln(t++) )
		if( yb >= ybe )
			return;
	for( ; dp.ad>rlend(dp.tl,r); ++r,++yb );
	yb = H * Max( yb, -100 ); // ɂ͂ݏo߂Ȃ悤
	if( yb >= cy() )
		return;

	// Psڂĕ`
	int rb = (r==0 ? 0 : rlend(dp.tl,r-1));
	int xb = left() + Max( 0UL,
		CalcLineWidth(doc_.tl(dp.tl)+rb,dp.ad-rb) -rlScr_.nPos );
	if( xb < right() )
	{
		RECT rc={xb,yb,right(),yb+H};
		::InvalidateRect( hwnd_, &rc, FALSE );
	}

	// c
	int ye;
	yb += H;
	if( afterall )
		xb=0, ye=cy();
	else
		xb=left(), ye=Min(cy(),yb+(int)(H*(rln(dp.tl)-r-1)));
	if( yb < ye )
	{
		RECT rc={xb,yb,right(),ye};
		::InvalidateRect( hwnd_, &rc, FALSE );
	}
}
